=== modified file '__init__.py'
--- __init__.py	2005-10-18 20:17:59 +0000
+++ __init__.py	2005-10-24 04:07:55 +0000
@@ -131,7 +131,9 @@
     from doctest import DocTestSuite
     from unittest import TestSuite
     import clean_tree
+    import blackbox
     result = TestSuite()
     result.addTest(DocTestSuite(bzrtools))
     result.addTest(clean_tree.test_suite())
+    result.addTest(blackbox.test_suite())
     return result

=== added file 'blackbox.py'
--- blackbox.py	1970-01-01 00:00:00 +0000
+++ blackbox.py	2005-10-24 04:07:55 +0000
@@ -0,0 +1,30 @@
+from bzrlib.selftest.blackbox import ExternalBase
+from unittest import makeSuite
+import os.path
+class TestBzrTools(ExternalBase):
+    @staticmethod
+    def touch(filename):
+        file(filename, 'wb').write('')
+
+    def test_clean_tree(self):
+        self.runbzr('init')
+        self.touch('name')
+        self.touch('name~')
+        assert os.path.lexists('name~')
+        self.touch('name.pyc')
+        self.runbzr('clean-tree')
+        assert os.path.lexists('name~')
+        assert not os.path.lexists('name')
+        self.runbzr('clean-tree --detrius')
+        assert not os.path.lexists('name~')
+        assert os.path.lexists('name.pyc')
+        self.runbzr('clean-tree --ignored')
+        assert not os.path.lexists('name.pyc')
+
+    def test_shelve(self):
+        self.runbzr('init')
+        self.runbzr('commit -m uc --unchanged')
+        self.runbzr('shelve -r 1 -m foo', retcode=1)
+
+def test_suite():
+    return makeSuite(TestBzrTools)

